#ifndef __KEYS_CPP__
#define __KEYS_CPP__

// things to do with private keys and certificates

#include <bits/types/FILE.h>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <string>
#include <vector>
#include "types.h"
#include "ossl-setup.h"

struct keyCertPair *keys;
int keyslen;

/* Keys manifest spec:

# is a comment

# specify a hostname
hostname cert key

# example
xn--la-fka.de loa.pem loa-key.pem
# wildcards need to be specified seperatly, (so for a *.löa.de cert you need to spec *.löa.de, and löa.de)
*.xn--la-fka.de loa.pem loa-key.pem

# spaces are allways seperators, spaces in filenames is not supported (no escaping either)
# line endings are allways unix style \n
*/
void readKeyManifest(){
    FILE *fp = fopen("keys.manifest", "r+");

    char c;

    /*
    0 = hostname
    1 = key
    2 = cert
    3 = comment, seeking next line
    */
    int state = 0;
    int count = 0;

    std::vector<std::vector<std::string>> manif;
    manif.push_back(std::vector<std::string>(3));

    while ((c = getc(fp))!=EOF) {
        if(state==3){
            if(c!='\n') continue;
            else state=0;
        }
        if(c=='#') state=3;

        if(c==' ' || c=='\n'){
            if(c=='\n'){count++;state=0; manif.push_back(std::vector<std::string>(3));}
            else state++;
    
            manif.at(count).push_back("");
            
            continue;
        }

        if(state<=2){
            manif.at(count).at(state) += c; 
        }
    }
    int len=0;
    for (int i=0; i<manif.size(); i++) {
        if(manif.at(i).at(0).size()>0 && manif.at(i).at(1).size()>0 && manif.at(i).at(2).size()>0){
            len++;
        }
    }
    struct keyCertPair *tkeys=(struct keyCertPair*)malloc(sizeof(struct keyCertPair)*len);
    int p=0;
    for (int i=0; i<manif.size(); i++) {
        if(manif.at(i).at(0).size()>0 && manif.at(i).at(1).size()>0 && manif.at(i).at(2).size()>0){
            char *str1 = (char*)malloc(manif.at(p).at(0).size()+1);
            strcpy(str1, manif.at(p).at(0).c_str());

            char *str2 = (char*)malloc(manif.at(p).at(1).size()+1);
            strcpy(str2, manif.at(p).at(1).c_str());

            char *str3 = (char*)malloc(manif.at(p).at(2).size()+1);
            strcpy(str3, manif.at(p).at(2).c_str());

            tkeys[p].hostname=str1;
            tkeys[p].certfn=str2;
            tkeys[p].keyfn=str3;
            p++;
        }
    }
    keyslen=len;
    keys=tkeys;
}

void loadKeyCertPairs(struct keyCertPair keys[], int len){
    for(int i = 0; i<len; i++){
        keys[i].ctx=createContext();
        configureContext(keys[i].ctx, keys[i].certfn, keys[i].keyfn);
        std::cout<<"loaded certificate and key for: "<<keys[i].hostname<<"\n";
    }
}

void freeKeys(struct keyCertPair keys[], int len){
    for(int i = 0; i<len; i++){
        SSL_CTX_free(keys[i].ctx);
    }
}

#endif