#ifndef __OSSL_SETUP_CPP__
#define __OSSL_SETUP_CPP__

// Stuff to setup OpenSSL and creating a socket
 
#include <asm-generic/errno-base.h>
#include <errno.h>
#include <asm-generic/errno.h>
#include <asm-generic/socket.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <iostream>
#include <poll.h>
#include "ossl-setup.h"

int createSocket(int port){
    int sock;
    struct sockaddr_in addr;

    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);
    addr.sin_addr.s_addr = htonl(INADDR_ANY);

    sock = socket(AF_INET, SOCK_STREAM, 0);
    if(sock < 0){
        std::cerr<<"Can't create socket\n";
        exit(EXIT_FAILURE);
    }

    if(bind(sock, (struct sockaddr*)&addr, sizeof(addr)) < 0){
        std::cerr<<"Can't bind\n";
        exit(EXIT_FAILURE);
    }

    if(listen(sock, 1) < 0){
        std::cerr<<"Can't listen\n";
        exit(EXIT_FAILURE);
    }
    
    return sock;
}


int createSocketClient(char *ip, int port){
    int sock;
    struct sockaddr_in addr;

    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);
    if(inet_pton(AF_INET, ip, &addr.sin_addr)<=0){
        std::cout<<"Address "<<ip<<" not supported.";
    }
    std::cout<<"addr: " << addr.sin_addr.s_addr<<"\n";
    std::cout<<"port: " << port<<"\n";

    sock = socket(AF_INET, SOCK_STREAM | SOCK_NONBLOCK , 0);
    if(sock==-1){
        std::cerr<<"socket() error: "<<errno<<"\n";
    }
    int ret = connect(sock, (struct sockaddr*)&addr, sizeof(addr));
    if( ret != 0 && errno != EINPROGRESS){
        std::cerr<<"connect() failed with code: "<<errno<<"\n";
    }
    std::cout<< "here\n";
    struct pollfd polld{
        sock,
        POLLOUT,
        0
    };
    poll(&polld,1,10000);

    if(!(polld.revents & POLLOUT)){
        std::cerr<<"poll failed with revent: "<<polld.revents<<"\n";
    }

    int err;
    unsigned int len(sizeof(err));

    if(getsockopt(sock, SOL_SOCKET, SO_ERROR, &err, &len)==-1){
        std::cerr<<"getsockopt failed\n";
    }

    if(err!=0){
        std::cerr<<"connection failed. code: "<<err<<"\n";
    }

    
    return sock;
}

SSL_CTX *createContext(){
    const SSL_METHOD *method;
    SSL_CTX *ctx;

    method = TLS_server_method();

    ctx = SSL_CTX_new(method);
    if(!ctx){
        std::cerr<<"Can't create context\n";
        ERR_print_errors_fp(stderr);
        exit(EXIT_FAILURE);
    }

    return ctx;
}

void configureContext(SSL_CTX *ctx, const char *cert, const char *key){
    // load certificate
    if(SSL_CTX_use_certificate_file(ctx, cert, SSL_FILETYPE_PEM) <= 0){
        std::cerr<<"Can't load certificate: "<<cert<<"\n";
        ERR_print_errors_fp(stderr);
        exit(EXIT_FAILURE);
    }

    // load key
    if(SSL_CTX_use_PrivateKey_file(ctx, key, SSL_FILETYPE_PEM) <= 0){
        std::cerr<<"Can't load key: "<<key<<"\n";
        ERR_print_errors_fp(stderr);
        exit(EXIT_FAILURE);
    }
}

#endif